import { Component, Directive, ComponentFactoryResolver, Compiler, NgModule, ComponentRef, ElementRef, ViewChild, ViewContainerRef, Input } from '@angular/core';
import { IgGridComponent, Column, Feature } from "../src/igniteui.angular2";
import { FormsModule } from '@angular/forms';
import { Northwind } from "./../samples/data/northwind.ts";
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic }	from '@angular/platform-browser-dynamic';
import { James } from './james.ts';


declare var jQuery: any;

@Directive({
	selector: 'my-column',
	inputs: ['key', 'headerText', 'template', 'width', 'dataType'],
	providers: [{provide: Column, useExisting: MyColumn }]
})
export class MyColumn extends Column {
	cmpRef: ComponentRef<James>;
	factory: any;

	constructor(private componentFactoryResolver: ComponentFactoryResolver, private viewContainerRef:ViewContainerRef, el: ElementRef) {
		super(el);
	}

	ngOnInit() {
		var that = this;

		function template(tmpl, data) {
			that.factory = that.componentFactoryResolver.resolveComponentFactory(James);
			let cmpRef = that.viewContainerRef.createComponent(that.factory);
			cmpRef.changeDetectorRef.detectChanges();
			return "";
		}
		jQuery.ig.tmpl = template;
	}
}


@Component({
	selector: 'my-app',
	templateUrl: "./app/igGridTemplate.html"
})
export class AppComponent {
	private gridOptions: IgGrid;
	private id: string;
	private data: any;

	constructor() {
		this.data = Northwind.getData();

		this.id ='grid1';
	}

	renderedCallback($event) {
		let jamesComponents = jQuery("my-james");
		jQuery($event.ui.owner.element)
			.find("tbody td[aria-describedby='grid1_CustomComponent']")
			.each((index, element)=> {
				jamesComponents.eq(index).appendTo(element);
			});
	}
}

@NgModule({
	imports:	  [ BrowserModule, FormsModule ],
	declarations: [ AppComponent, IgGridComponent, Column, MyColumn, Feature, James ],
	entryComponents: [ James ],
	bootstrap:	[ AppComponent ]
})
export class AppModule {}

platformBrowserDynamic().bootstrapModule(AppModule);
